include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_prop : \forall (return_:nat -> Prop). (return_ (O) ) -> (\forall (n:nat). return_ ((S)  n)) -> \forall (z:nat). return_ z.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O.
definition eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
definition sym_eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) case_O ((match_nat_type) (return_type) case_O case_S (O) ) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom minus : nat -> nat -> nat.
axiom minus_body : nat -> nat -> nat.
axiom axiom_minus : \forall (n:nat). (equal) (nat -> nat) ((minus)  n) ((filter_nat_type) (nat -> nat) (minus_body)  n).
definition eq_minus : \forall (n:nat). (leibniz) (nat -> nat) ((minus)  n) ((filter_nat_type) (nat -> nat) (minus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((minus)  n)) ((filter_nat_type) (nat -> nat) (minus_body)  n)) ((axiom_minus) (n)).
definition sym_eq_minus : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (minus_body)  n) ((minus)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((minus)  n)) ((filter_nat_type) (nat -> nat) (minus_body)  n)) ((eq_minus) (n)).
axiom axiom_minus_body_O : (equal) (nat -> nat) ((minus_body)  (O) ) (\lambda m : nat. (O) ).
definition eq_minus_body_O : (leibniz) (nat -> nat) ((minus_body)  (O) ) (\lambda m : nat. (O) ) := ((((equal_leibniz) (nat -> nat)) ((minus_body)  (O) )) (\lambda m : nat. (O) )) (axiom_minus_body_O).
definition sym_eq_minus_body_O : (leibniz) (nat -> nat) (\lambda m : nat. (O) ) ((minus_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((minus_body)  (O) )) (\lambda m : nat. (O) )) (eq_minus_body_O).
axiom axiom_minus_body_S : \forall (n:nat). (equal) (nat -> nat) ((minus_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m).
definition eq_minus_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((minus_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((minus_body)  ((S)  n))) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m)) ((axiom_minus_body_S) (n)).
definition sym_eq_minus_body_S : \forall (n:nat). (leibniz) (nat -> nat) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m) ((minus_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((minus_body)  ((S)  n))) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m)) ((eq_minus_body_S) (n)).
definition minus_O_n : \forall (n:nat). (eq) (nat) (O)  ((minus)  (O)  n) := \lambda n : nat. ((((match_nat_prop) (\lambda j__ : nat. (eq) (nat) (O)  ((minus)  (O)  j__))) ((((sym_eq_minus) ((O) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((minus_body) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((sym_eq_minus_body_O) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((refl) (nat)) ((O) )))))) ((((sym_eq_minus) ((O) )) (\lambda y : nat -> nat. \forall (n0:nat). (eq) (nat) (O)  (y ((S)  n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((minus_body) )) (\lambda y : nat -> nat. \forall (n0:nat). (eq) (nat) (O)  (y ((S)  n0)))) (((sym_eq_minus_body_O) (\lambda y : nat -> nat. \forall (n0:nat). (eq) (nat) (O)  (y ((S)  n0)))) (\lambda auto : nat. ((refl) (nat)) ((O) )))))) (n).
definition minus_n_O : \forall (n:nat). (eq) (nat) n ((minus)  n (O) ) := \lambda n : nat. ((((match_nat_prop) (\lambda j__ : nat. (eq) (nat) j__ ((minus)  j__ (O) ))) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) (O)  j__)) (((refl) (nat)) ((O) ))) ((minus)  (O)  (O) )) ((minus_O_n) ((O) )))) (\lambda auto : nat. (((sym_eq_minus) ((S)  auto)) (\lambda y : nat -> nat. (eq) (nat) ((S)  auto) (y (O) ))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((minus_body) )) (auto)) (\lambda y : nat -> nat. (eq) (nat) ((S)  auto) (y (O) ))) ((((sym_eq_minus_body_S) (auto)) (\lambda y : nat -> nat. (eq) (nat) ((S)  auto) (y (O) ))) ((((((sym_eq_match_nat_type_O) (nat)) ((S)  auto)) (\lambda q : nat. (minus)  auto q)) (\lambda y : nat. (eq) (nat) ((S)  auto) y)) (((refl) (nat)) ((S)  auto))))))) (n).
